The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Resonate Class Reference

STK noise driven formant filter. More...

`#include <Resonate.h>`

Inheritance diagram for stk::Resonate:

List of all members.

## Public Member Functions
| Resonate (void)
| Class constructor.
| ~Resonate (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setResonance (StkFloat frequency, StkFloat radius)
| Set the filter for a resonance at the given frequency (Hz) and radius.
void | setNotch (StkFloat frequency, StkFloat radius)
| Set the filter for a notch at the given frequency (Hz) and radius.
void | setEqualGainZeroes (void)
| Set the filter zero coefficients for contant resonance gain.
void | keyOn (void)
| Initiate the envelope with a key-on event.
void | keyOff (void)
| Signal a key-off event to the envelope.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK noise driven formant filter.

This instrument contains a noise source, which excites a biquad resonance filter, with volume controlled by an ADSR.

Control Change Numbers:

- Resonance Frequency (0-Nyquist) = 2
- Pole Radii = 4
- Notch Frequency (0-Nyquist) = 11
- Zero Radii = 1
- Envelope Gain = 128

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

StkFrames & stk::Resonate::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

    00099 {
    00100   unsigned int nChannels = lastFrame_.channels();
    00101 #if defined(_STK_DEBUG_)
    00102   if ( channel > frames.channels() - nChannels ) {
    00103     oStream_ << "Resonate::tick(): channel and StkFrames arguments are incompatible!";
    00104     handleError( StkError::FUNCTION_ARGUMENT );
    00105   }
    00106 #endif
    00107
    00108   StkFloat *samples = &frames[channel];
    00109   unsigned int j, hop = frames.channels() - nChannels;
    00110   if ( nChannels == 1 ) {
    00111     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00112       *samples++ = tick();
    00113   }
    00114   else {
    00115     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00116       *samples++ = tick();
    00117       for ( j=1; j<nChannels; j++ )
    00118         *samples++ = lastFrame_[j];
    00119     }
    00120   }
    00121
    00122   return frames;
    00123 }

The documentation for this class was generated from the following file:

- Resonate.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.